## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch: %{ix86}

# Switch to Clang due LTO regression in GCC
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=114501
%global toolchain clang

%global forgeurl https://github.com/Chatterino/%{name}
%global uuid com.chatterino.chatterino
%global chatterino_git_commit 3aead09339ffff0fbfd9f8a7a5ea9eb551ad8fb8
%global chatterino_git_shortcommit %(c=%{chatterino_git_commit}; echo ${c:0:7})
%global tarball_version %%(echo %{version} | tr '~' '-')

# Git submodules
#   * libcommuni
%global commit2         030710ad53dda1541601ccabbad36a12a9e90c78
%global shortcommit2    %(c=%{commit2}; echo ${c:0:7})

#   * settings
%global commit3         9e9c2f65f4ae195a96329a90fd6ae24c24fb8f2f
%global shortcommit3    %(c=%{commit3}; echo ${c:0:7})

#   * signals
%global commit4         d06770649a7e83db780865d09c313a876bf0f4eb
%global shortcommit4    %(c=%{commit4}; echo ${c:0:7})

#   * serialize
%global commit5         17946d65a41a72b447da37df6e314cded9650c32
%global shortcommit5    %(c=%{commit5}; echo ${c:0:7})

#   * magic_enum
%global commit9         e55b9b54d5cf61f8e117cafb17846d7d742dd3b4
%global shortcommit9    %(c=%{commit9}; echo ${c:0:7})

#   * sanitizers-cmake
%global commit10        0573e2ea8651b9bb3083f193c41eb086497cc80a
%global shortcommit10   %(c=%{commit10}; echo ${c:0:7})

#   * miniaudio
%global commit11        4a5b74bef029b3592c54b6048650ee5f972c1a48
%global shortcommit11   %(c=%{commit11}; echo ${c:0:7})

#   * expected-lite
%global commit12        5b5caad7cd57d5ba3ca796bf1521b131d73ca405
%global shortcommit12   %(c=%{commit12}; echo ${c:0:7})

Name:           chatterino2
Version:        2.5.2
%forgemeta
Release:        %autorelease
Summary:        Chat client for https://twitch.tv

# Boost Software License (v1.0) Boost Software License 1.0
# -----------------------------------------------------------------------
# resources/licenses/boost_boost.txt
#
# BSD 3-clause "New" or "Revised" License
# ---------------------------------------
# lib/libcommuni/
#
# Expat License
# -------------
# lib/serialize/
# lib/signals/
# resources/
#
# Mozilla Public License (v1.1) GNU General Public License (v2 or later) or GNU Lesser General Public License (v2.1 or later)
# ---------------------------------------------------------------------------------------------------------------------------
# lib/libcommuni/
#
# zlib/libpng license Aladdin Free Public License
# -----------------------------------------------
# lib/websocketpp/
#
License:        MIT and BSL-1.0 and BSD-3-Clause and zlib and GPL-2.0-or-later and LGPL-2.1-or-later and MPL-1.1

URL:            %{forgeurl}
Source0:        %{forgesource}
Source2:        https://github.com/hemirt/libcommuni/archive/%{commit2}/libcommuni-%{shortcommit2}.tar.gz
Source3:        https://github.com/pajlada/settings/archive/%{commit3}/settings-%{shortcommit3}.tar.gz
Source4:        https://github.com/pajlada/signals/archive/%{commit4}/signals-%{shortcommit4}.tar.gz
Source5:        https://github.com/pajlada/serialize/archive/%{commit5}/serialize-%{shortcommit5}.tar.gz
Source9:        https://github.com/Neargye/magic_enum/archive/%{commit9}/magic_enum-%{shortcommit9}.tar.gz
Source10:       https://github.com/arsenm/sanitizers-cmake/archive/%{commit10}/sanitizers-cmake-%{shortcommit10}.tar.gz
Source11:       https://github.com/mackron/miniaudio/archive/%{commit11}/miniaudio-%{shortcommit11}.tar.gz
Source12:       https://github.com/martinmoene/expected-lite/archive/%{commit12}/expected-lite-%{shortcommit12}.tar.gz


BuildRequires:  boost-devel
BuildRequires:  clang
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  libappstream-glib
BuildRequires:  make

BuildRequires:  cmake(Qt6Concurrent)
BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6Gui)
BuildRequires:  cmake(Qt6Keychain)
BuildRequires:  cmake(Qt6LinguistTools)
BuildRequires:  cmake(Qt6Multimedia)
BuildRequires:  cmake(Qt6Network)
BuildRequires:  cmake(Qt6Svg)
BuildRequires:  cmake(Qt6Widgets)
BuildRequires:  cmake(Qt6Core5Compat)
BuildRequires:  cmake(RapidJSON)

BuildRequires:  pkgconfig(libsecret-1)
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig(websocketpp)
BuildRequires:  pkgconfig(xkbcommon)

Requires:       hicolor-icon-theme
Requires:       qt6-qtsvg
Requires:       qt6-qtimageformats

# Current submodules patched so not possible to build with system packages
#   * https://github.com/Chatterino/chatterino2/issues/1444
Provides:       bundled(expected-lite) = 0.8.0~git%{shortcommit12}
Provides:       bundled(libcommuni) = 3.7.0~git%{shortcommit2}
Provides:       bundled(magic_enum) = 0.9.3~git%{shortcommit9}
Provides:       bundled(miniaudio) = 0.11.18~git%{shortcommit11}
Provides:       bundled(sanitizers-cmake) = 0~git%{shortcommit10}
Provides:       bundled(serialize) = 0~git%{shortcommit5}
Provides:       bundled(settings) = 0~git%{shortcommit3}
Provides:       bundled(signals) = 0.1.0~git%{shortcommit4}

%description
Chatterino 2 is a chat client for Twitch.tv. The Chatterino 2 wiki can be
found https://wiki.chatterino.com/.


%prep
%forgesetup
%setup -n %{name}-%{tarball_version} -q -D -T -a2
%setup -n %{name}-%{tarball_version} -q -D -T -a3
%setup -n %{name}-%{tarball_version} -q -D -T -a4
%setup -n %{name}-%{tarball_version} -q -D -T -a5
%setup -n %{name}-%{tarball_version} -q -D -T -a9
%setup -n %{name}-%{tarball_version} -q -D -T -a10
%setup -n %{name}-%{tarball_version} -q -D -T -a11
%setup -n %{name}-%{tarball_version} -q -D -T -a12

mv libcommuni-%{commit2}/*  lib/libcommuni
mv settings-%{commit3}/*    lib/settings
mv signals-%{commit4}/*     lib/signals
mv serialize-%{commit5}/*   lib/serialize
mv magic_enum-%{commit9}/*  lib/magic_enum
mv miniaudio-%{commit11}/*  lib/miniaudio
mv expected-lite-%{commit12}/* lib/expected-lite
mv sanitizers-cmake-%{commit10}/* cmake/sanitizers-cmake


%build
export GIT_COMMIT=%{chatterino_git_commit}
export GIT_HASH=%{chatterino_git_shortcommit}
export GIT_RELEASE=%{version}
%cmake \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DBUILD_WITH_QT6=ON \
    -DUSE_PRECOMPILED_HEADERS=0FF \
    -DUSE_SYSTEM_QTKEYCHAIN=ON \
    -DBUILD_WITH_QTKEYCHAIN=ON \
    %{nil}
%cmake_build


%install
%cmake_install
install -Dpm 0644 resources/%{uuid}.appdata.xml   \
    %{buildroot}%{_metainfodir}/%{uuid}.appdata.xml
install -Dpm 0644 resources/icon.png              \
    %{buildroot}%{_datadir}/icons/hicolor/256x256/apps/chatterino.png


%check
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/*.xml
desktop-file-validate %{buildroot}%{_datadir}/applications/*.desktop


%files
%license LICENSE
%doc README.md BUILDING_ON_LINUX.md docs/
%{_bindir}/chatterino
%{_datadir}/applications/*.desktop
%{_datadir}/icons/hicolor/*/*/*.png
%{_metainfodir}/*.xml


%changelog
## START: Generated by rpmautospec
* Sun Jan 05 2025 Packit <hello@packit.dev> - 2.5.2-1
- Update to 2.5.2 upstream release
- Resolves: rhbz#2335644

* Sun Dec 22 2024 Artem Polishchuk <ego.cordatus@gmail.com> - 2.5.1-6
- build: Fix GCC 15 build rh#2300589

* Wed Jul 17 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Tue May 21 2024 Jan Grulich <jgrulich@redhat.com> - 2.5.1-4
- Rebuild (qt6)

* Fri May 03 2024 Artem Polishchuk <ego.cordatus@gmail.com> - 2.5.1-3
- build: Desc update and some chores

* Fri May 03 2024 Artem Polishchuk <ego.cordatus@gmail.com> - 2.5.1-2
- build: Switch to Clang due LTO regression in GCC

* Fri May 03 2024 Packit <hello@packit.dev> - 2.5.1-1
- Update to 2.5.1 upstream release
- Resolves: rhbz#2276309

* Thu Apr 04 2024 Jan Grulich <jgrulich@redhat.com> - 2.4.6-12
- Rebuild (qt6)

* Tue Jan 23 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.6-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.6-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Oct 08 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.6-9
- packit: Add upstream_tag_template: v{version}

* Sat Oct 07 2023 Christian Birk <mail@birkc.de> - 2.4.6-8
- fix: add missing dependency and add optional build dependency

* Fri Oct 06 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.6-7
- build: Add Packit config

* Fri Oct 06 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.6-6
- build: Use forge macros

* Tue Oct 03 2023 Christian Birk <mail@birkc.de> - 2.4.6-5
- Migrate to QT6

* Tue Oct 03 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.6-4
- license: Convert to SPDX

* Tue Oct 03 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.6-3
- Revert "chore: Upload sources"

* Tue Oct 03 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.6-2
- chore: Upload sources

* Tue Oct 03 2023 Christian Birk <mail@birkc.de> - 2.4.6-1
- chore: Update to 2.4.6

* Wed Sep 20 2023 Christian Birk <mail@birkc.de> - 2.4.5-5
- migrate to system provided websocketpp

* Tue Sep 05 2023 Christian Birk <mail@birkc.de> - 2.4.5-4
- Change build type to RelWithDebInfo add versioninfo

* Sun Aug 27 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.5-3
- build: Add missed sources

* Sun Aug 27 2023 Christian Birk <mail@birkc.de> - 2.4.5-2
- Update miniaudio for the latest release. Fix dependency numbers for
  shortcommit11 and shortcommit12 to reflext the correct commits.

* Sun Aug 27 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.5-1
- chore: Update to 2.4.5 (rh#2195932)

* Sun Aug 27 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.4-1
- chore: Update to 2.4.4

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sun May 07 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.3-1
- chore: Update to 2.4.3

* Wed Mar 08 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.2-1
- chore: Update to 2.4.2

* Mon Feb 20 2023 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.1-1
- build: Update to 2.4.1

* Wed Jan 18 2023 Fedora Release Engineering <releng@fedoraproject.org> - 2.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Dec 01 2022 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.0-1
- build: Update to 2.4.0

* Thu Nov 24 2022 Artem Polishchuk <ego.cordatus@gmail.com> - 2.4.0~beta-1
- build: Update to 2.4.0-beta

* Thu Nov 24 2022 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.5-6
- build: ExcludeArch: %%{ix86}

* Thu Nov 24 2022 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.5-5
- build: Add Requires: qt5-qtsvg

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed May 04 2022 Thomas Rodgers <trodgers@redhat.com> - 2.3.5-2
- Rebuilt for Boost 1.78

* Sat Apr 09 2022 Christian Birk <mail@birkc.de> - 2.3.5-1
- Update to 2.3.5 | rh#2073690

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Sep 14 2021 Sahana Prasad <sahana@redhat.com> - 2.3.4-3
- Rebuilt with OpenSSL 3.0.0

* Wed Aug 18 2021 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.4-2
- build: Rebuilt for Boost | rh#1991862

* Sun Aug 08 2021 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.4-1
- build(update): 2.3.4

* Fri Aug 06 2021 Jonathan Wakely <jwakely@redhat.com> - 2.3.3-3
- Rebuilt for Boost 1.76

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2.3.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu Jul 15 2021 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.3-1
- build(update): 2.3.3

* Mon May 17 2021 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.2-1
- build(update): 2.3.2

* Tue May 04 2021 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.1-1
- build(update): 2.3.1

* Wed Apr 14 2021 Artem Polishchuk <ego.cordatus@gmail.com> - 2.3.0-1
- build(update): 2.3.0

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 2.2.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Fri Jan 22 2021 Jonathan Wakely <jwakely@redhat.com> - 2.2.2-2
- Rebuilt for Boost 1.75

* Thu Nov  5 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.2.2-1
- build(update): 2.2.2

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.1.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Sat May 30 2020 Jonathan Wakely <jwakely@redhat.com> - 2.1.7-2
- Rebuilt for Boost 1.73

* Fri Feb 28 2020 Artem Polishchuk <ego.cordatus@gmail.com> - 2.1.7-1
- Update to 2.1.7
- Add new submodule 'qtkeychain'
- Drop patches (upstreamed now)
- Disable LTO

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 2.1.4-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sat Dec 21 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 2.1.4-8
- Build with system 'rapidjson'

* Fri Dec 13 2019 Artem Polishchuk <ego.cordatus@gmail.com> - 2.1.4-7
- Initial package

## END: Generated by rpmautospec
